Codeforces Round #277 (Div. 2)
A. 計算関数
テストごとの制限時間
1 秒
テストごとのメモリ制限
256 メガバイト
入力
標準入力
出力
標準出力
正の整数 n の場合、関数 f:
f(n)?=??-?1?+?2?- を定義しましょう。 ?3?+?..?+?(?-?1)nn
あなたのタスクは、指定された整数 n に対して f(n) を計算することです。
入力
1 行には正の整数 n が含まれています( 1?≤?n?≤?1015)。
出力
f(n) を 1 行で出力します。
サンプルテスト
入力
出力
入力
出力
-3
注意
f(4)?=??-?1?+?2?-?3?+?4?=?2
f(5) ?=??-?1?+?2?-?3?+?4?-?5?=??-?3
简单公式:
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>using namespace std;typedef long long int LL;LL n;int main(){ cin>>n; if(n%2==0) { LL t=n/2; cout<<t<<endl; } else { LL t=(n-1)/2; cout<<t-n<<endl; } return 0;}
行列の B. OR
テストごとの制限時間
1 秒
テストごとのメモリ制限
256 メガバイト
入力 標準入力
出力 標準出力
論理を定義しましょう2 つの論理値に対する演算としての OR (i. e.セット {0,?1} に属する値)。論理値の一方または両方が 1 に設定されている場合は 1 に等しく、そうでない場合は 0 です。同じ論理値で 3 つ以上の論理値の論理和を定義できます。マナー:
ここで、ai?=?1 の場合は 1 に等しく、そうでない場合は 0 に等しいです。
Nam には m 行と n 列で構成される行列 A があります。行には 1 から m までの番号が付けられ、列には 1 から n までの番号が付けられます。行i(1?≤?i?≤?m)、列j(1?≤?j?≤?n)の要素はAijと表されます。 A のすべての要素は 0 または 1 です。Nam は行列 A から、次の式を使用して同じサイズの別の行列 B を作成します:
.
(Bij は行列 A の行 i と列 j のすべての要素の OR です)
Nam は行列 B を与え、行列 A を推測するように要求します。Nam は賢いですが、A のサイズが大きくなる可能性があるため、おそらく行列 B の計算中に間違いを犯す可能性があります。
入力
最初の行には 2 つの整数が含まれていますm と n (1?≤?m,?n?≤?100)、それぞれ行列の行数と列数です
次の m 行にはそれぞれ、行列 B の行を表すスペースで区切られた n 個の整数が含まれています (各要素B の値は 0 または 1)。
出力
最初の行で、Nam が B の計算を間違えた場合は「NO」を出力し、それ以外の場合は「YES」を出力します。最初の行が「YES」の場合、指定された行列 B を生成できる行列 A を表す n 整数で構成される m 行も出力します。複数の解がある場合は、いずれかを出力します。
サンプル テスト
input
2 21 00 0
output
NO
input
2 31 1 11 1 1
output
YES1 1 11 1 1
input
2 30 1 01 1 1
output
YES0 0 00 1 0
水题:将A里所有可能是1的点加上就可以了
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>using namespace std;int n,m;int B[220][220];int A[220][220];bool vis[220][220];bool check(int x,int y){ bool flag=true; for(int i=0;i<m&&flag;i++) { if(vis[x][i]==false&&B[x][i]==0) flag=false; } for(int i=0;i<n&&flag;i++) { if(vis[i][y]==false&&B[i][y]==0) flag=false; } return flag;}void CL(int x,int y){ for(int i=0;i<m;i++) vis[x][i]=true; for(int i=0;i<n;i++) vis[i][y]=true;}int main(){ cin>>n>>m; for(int i=0;i<n;i++) for(int j=0;j<m;j++) cin>>B[i][j]; for(int i=0;i<n;i++) { for(int j=0;j<m;j++) { if(check(i,j))///ONE { A[i][j]=1; CL(i,j); } } } bool flag=true; for(int i=0;i<n&&flag;i++) for(int j=0;j<m&&flag;j++) if(B[i][j]==1&&vis[i][j]==0) flag=false; if(flag) { puts("YES"); for(int i=0;i<n;i++) { for(int j=0;j<m;j++) cout<<A[i][j]<<" "; cout<<endl; } } else puts("NO"); return 0;}
C. Palindrome Transformation
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output
Nam is playing with a string on his computer. The string consists of n lowercase English letters. It is meaningless, so Nam decided to make the string more beautiful, that is to make it be a palindrome by using 4 arrow keys: left, right, up, down.
There is a cursor pointing at some symbol of the string. Suppose that cursor is at position i (1?≤?i?≤?n, the string uses 1-based indexing) now. Left and right arrow keys are used to move cursor around the string. The string is cyclic, that means that when Nam presses left arrow key, the cursor will move to position i?-?1 if i?>?1 or to the end of the string (i. e. position n) otherwise. The same holds when he presses the right arrow key (if i?=?n, the cursor appears at the beginning of the string).
When Nam presses up arrow key, the letter which the text cursor is pointing to will change to the next letter in English alphabet (assuming that alphabet is also cyclic, i. e. after 'z' follows 'a'). The same holds when he presses the down arrow key.
Initially, the text cursor is at position p.
Because Nam has a lot homework to do, he wants to complete this as fast as possible. Can you help him by calculating the minimum number of arrow keys presses to make the string to be a palindrome?
Input
The first line contains two space-separated integers n (1?≤?n?≤?105) and p (1?≤?p?≤?n), the length of Nam's string and the initial position of the text cursor.
The next line contains n lowercase characters of Nam's string.
Output
Print the minimum number of presses needed to change string into a palindrome.
Sample test(s)
input
8 3aeabcaez
output
Note
A string is a palindrome if it reads the same forward or reversed.
In the sample test, initial Nam's string is: (cursor position is shown bold).
In optimal solution, Nam may do 6 following steps:
The result, , is now a palindrome.
因为没有删除操作,最后的回文串是什么样已经是确定的了, A-->A' 或 A'--->A 或到A和A'的中间值上下移动的次数是一样的,所以没有必要跨越中点
只要计算出在一边的左右移动次数就可以了....
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>using namespace std;const int maxn=200100;const int INF=0x3f3f3f3f;char str[maxn];char rstr[maxn];int n,p;int change[maxn][2];void getC(){ for(int i=0;i<n;i++) { /// 0: A --> A' change[i][0]=max(str[i],rstr[i])-min(str[i],rstr[i]); change[i][0]=min(change[i][0],min(str[i],rstr[i])+26-max(str[i],rstr[i])); /// 1: A --> m <-- A' change[i][1]=change[i][0]; }}int main(){ cin>>n>>p; p--; cin>>str; int tt=n/2; if(n%2==0) tt--; if(p>tt) { reverse(str,str+n); p=n-1-p; } memcpy(rstr,str,sizeof(str)); reverse(rstr,rstr+n); getC(); int temp=0; ///改变字符的花费 for(int i=0;i<=tt;i++) { temp+=change[i][0]; } ///移动的花费 ///需要改变的左右边界 int R=-1; for(int i=tt;i>=0;i--) { if(change[i][0]!=0) { R=i; break; } } int L=-1; for(int i=0;i<=tt;i++) { if(change[i][0]!=0) { L=i; break; } } if(L==-1||R==-1) { puts("0"); } else if(L==R) { cout<<abs(p-L)+temp<<endl; } else { /// L <----> R if(p>=L&&p<=R) { int t=min(abs(R-p),abs(L-p)); cout<<R-L+t+temp<<endl; } else if(p<L) { cout<<abs(R-p)+temp<<endl; } else if(p>R) { cout<<abs(L-p)+temp<<endl; } } return 0;}
D. Valid Sets
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output
As you know, an undirected connected graph with n nodes and n?-?1 edges is called a tree. You are given an integer d and a tree consisting of nnodes. Each node i has a value ai associated with it.
We call a set S of tree nodes valid if following conditions are satisfied:
Your task is to count the number of valid sets. Since the result can be very large, you must print its remainder modulo 1000000007 (109?+?7).
Input
The first line contains two space-separated integers d (0?≤?d?≤?2000) and n (1?≤?n?≤?2000).
The second line contains n space-separated positive integers a1,?a2,?...,?an(1?≤?ai?≤?2000).
Then the next n?-?1 line each contain pair of integers u and v (1?≤?u,?v?≤?n) denoting that there is an edge between u and v. It is guaranteed that these edges form a tree.
Output
Print the number of valid sets modulo 1000000007.
Sample test(s)
input
1 42 1 3 21 21 33 4
output
input
0 31 2 31 22 3
output
input
4 87 8 7 5 4 6 4 101 61 25 81 33 56 73 4
output
41
Note
In the first sample, there are exactly 8 valid sets: {1},?{2},?{3},?{4},?{1,?2},?{1,?3},?{3,?4} and {1,?3,?4}. Set {1,?2,?3,?4} is not valid, because the third condition isn't satisfied. Set {1,?4} satisfies the third condition, but conflicts with the second condition.
树型DP,从每一个节点走只扩展和根节点 root 权值 在 root<=w[v]<=root+D 之内的点, DP[u]= 所有子节点(DP[v]+1)相乘
如果扩展到某个节点 w[v]==w[root] 则标记一下,不要重复走
#include <iostream>#include <cstring>#include <cstdio>#include <algorithm>#include <vector>using namespace std;typedef long long int LL;const int maxn=2222;const LL mod=1000000007;int n,d,root;LL w[maxn];vector<int> g[maxn];bool vis[maxn][maxn];LL dp[maxn];LL dfs(int u,int fa){ dp[u]=1; for(int i=0,sz=g[u].size();i<sz;i++) { int v=g[u][i]; if(v==fa) continue; if(!((w[root]<=w[v])&&(w[v]<=w[root]+d))) continue; if(vis[root][v]) continue; if(w[root]==w[v]) vis[root][v]=vis[v][root]=true; int temp=dfs(v,u); dp[u]=(dp[u]+temp*dp[u])%mod; } return dp[u];}int main(){ cin>>d>>n; for(int i=1; i<=n; i++) cin>>w[i]; for(int i=0; i<n-1; i++) { int a,b; cin>>a>>b; g[a].push_back(b); g[b].push_back(a); } LL sum=0; for(int i=1; i<=n; i++) { root=i; sum=(sum+dfs(i,i))%mod; } cout<<sum<<endl; return 0;}
E. LIS of Sequence
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output
The next "Data Structures and Algorithms" lesson will be about Longest Increasing Subsequence (LIS for short) of a sequence. For better understanding, Nam decided to learn it a few days before the lesson.
Nam created a sequence a consisting of n (1?≤?n?≤?105) elements a1,?a2,?...,?an (1?≤?ai?≤?105). A subsequence ai1,?ai2,?...,?aik where 1?≤?i1?
Nam realizes that a sequence may have several longest increasing subsequences. Hence, he divides all indexes i (1?≤?i?≤?n), into three groups:
Since the number of longest increasing subsequences of a may be very large, categorizing process is very difficult. Your task is to help him finish this job.
Input
The first line contains the single integer n (1?≤?n?≤?105) denoting the number of elements of sequence a.
The second line contains n space-separated integers a1,?a2,?...,?an (1?≤?ai?≤?105).
Output
Print a string consisting of n characters. i-th character should be '1', '2' or '3' depending on which group among listed above index i belongs to.
Sample test(s)
input
14
output
input
41 3 2 5
output
3223
input
41 5 2 3
output
3133
Note
In the second sample, sequence a consists of 4 elements: {a1,?a2,?a3,?a4} = {1,?3,?2,?5}. Sequence a has exactly 2 longest increasing subsequences of length 3, they are {a1,?a2,?a4} = {1,?3,?5} and {a1,?a3,?a4} = {1,?2,?5}.
In the third sample, sequence a consists of 4 elements: {a1,?a2,?a3,?a4} = {1,?5,?2,?3}. Sequence a have exactly 1 longest increasing subsequence of length 3, that is {a1,?a3,?a4} = {1,?2,?3}.
// Some notation is re-defined.
Let F1i be the length of LIS ending exactly at ai of sequence {a1,?a2,?...,?ai}.
Let F2i be the length of LIS beginning exactly at ai of sequence {ai,?ai?+?1,?...,?an}.
l = length of LIS of {a1,?a2,?...,?an} = max{F1i} = max{F2j}.
Let Fi be the length of LIS of sequence {a1,?a2,?...,?ai?-?1,?ai?+?1,?...,?an} (i.e the length of LIS of initial sequence a after removing element ai).
Index i must in group:
1) if F1i?+?F2i?-?1?
2) if Fi?=?l
3) if Fi?=?l?-?1
How to caculate Fi? We have: Fi?=?max{F1u?+?F2v} among 1?≤?u?
正反求两遍LIS,比较一下即可.....
如果F1[i]+F2[j]-1==LIS 要用map记录下有没有相同的F1[i],F2[i] 有输出2 没有输出3
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <vector>#include <set>#include <map>using namespace std;const int maxn=100100;int n,a[maxn],b[maxn];int f1[maxn],f2[maxn];int v1[maxn],n1,v2[maxn],n2;set<int> st;map<pair<int,int>,int> mp;int r[maxn],rn;int ans[maxn];int main(){ scanf("%d",&n); for(int i=0;i<n;i++) { scanf("%d",a+i); r[rn++]=a[i]; } sort(r,r+rn); rn=unique(r,r+rn)-r; ///.....rhash..... for(int i=0;i<n;i++) { int id=lower_bound(r,r+rn,a[i])-r; id=rn-1-id; b[n-1-i]=r[id]; } int LIS=1; for(int i=0;i<n;i++) { if(i==0) { v1[n1++]=a[i]; v2[n2++]=b[i]; f1[0]=f2[0]=1; } else { int p1=lower_bound(v1,v1+n1,a[i])-v1; v1[p1]=a[i]; if(p1==n1) n1++; f1[i]=p1+1; LIS=max(LIS,f1[i]); int p2=lower_bound(v2,v2+n2,b[i])-v2; v2[p2]=b[i]; if(p2==n2) n2++; f2[i]=p2+1; } } for(int i=0;i<n;i++) { int x=i,y=n-1-i; if(f1[x]+f2[y]-1<LIS) ans[i]=1; else if(f1[x]+f2[y]-1==LIS) { ans[i]=4; mp[make_pair(f1[x],f2[y])]++; } } for(int i=0;i<n;i++) { if(ans[i]==4) { int x=i,y=n-1-i; if(mp[make_pair(f1[x],f2[y])]==1) ans[i]=3; else ans[i]=2; } printf("%d",ans[i]); if(i==n-1) putchar('\n'); } return 0;}